code	segment	'code'
	assume	cs:code,ds:code

	org	100h

start:	mov	sp,0200h		; move stack pointer
	push	ax

	mov	bl,20h			; resize memory block
	mov	ah,4ah
	int	21h

	mov	ax,3509h		; get current handler
	int	21h
	mov	word ptr old09,bx
	mov	word ptr old09+2,es
	push	cs			; restore ES for EXEC
	pop	es

	mov	dx,offset new09		; install new handler
	mov	ah,25h
	int	21h

	mov	word ptr tail+2,cs	; set segments in param block
	mov	word ptr fcb1+2,cs
	mov	word ptr fcb2+2,cs

	mov	dx,offset prog		; EXEC child process
	mov	bx,offset parm
	mov	ax,4b00h
	int	21h

	mov	dx,word ptr old09	; restore old handler
	mov	ds,word ptr old09+2
	mov	ax,2509h
	int	21h

	ret

new09:	push	ax
	in 	al,60h
	cmp	al,0e0h			; extended key?
	jne	pass
	mov	al,20h			; shhh, don't tell BIOS
	out	20h,al
	pop	ax
	iret
pass:	pop	ax			; pass the key on to BIOS
int09:
	db	0eah
old09	dd	0

prog	db	'AR.EXE'		; program filename

parm	dw	0			; default env seg
tail	dd	80h			; command line tail pointer
fcb1	dd	5ch			; first FCB pointer
fcb2	dd	6ch			; second FCB pointer

code	ends

	end	start
